package rocks.zipcode.io.quiz4.collections;

import java.util.TreeSet;

/**
 * @author leon on 11/12/2018.
 */
public class ComparableTreeSet<T extends Comparable> extends TreeSet<T> implements Comparable<ComparableTreeSet<T>> {

    TreeSet<T> treeSet;

    public ComparableTreeSet(T... arr) {
        this.treeSet = new TreeSet<>();
        for(T item: arr) {
            this.treeSet.add(item);
        }
    }

    public ComparableTreeSet() {
        this.treeSet = new TreeSet<>();
    }

    public TreeSet<T> getTreeSet() {
        return treeSet;
    }

    public int compareTo(ComparableTreeSet<T> o) {

        return this.treeSet.first().compareTo(o.getTreeSet().first());
    }

    @Override
    public String toString() {
        StringBuilder str = new StringBuilder();
        str.append("[");

        for(T item: this.treeSet) {
            str.append(item.toString());
            str.append(", ");
        }
        str.deleteCharAt(str.length() - 1);
        str.deleteCharAt(str.length() - 1);

        return str + "]";
    }


}
