package rocks.zipcode.io.quiz4.collections;

import rocks.zipcode.io.quiz4.objectorientation.Student;

import java.util.*;

/**
 * @author leon on 11/12/2018.
 */
public class ZipCodeWilmington {

    List<Student> cohort;

    public ZipCodeWilmington() {
        this.cohort = new ArrayList<>();
    }

    public void enroll(Student student) {
        this.cohort.add(student);
    }

    public Boolean isEnrolled(Student student) {

        for(Student s: this.cohort) {
            if(s.equals(student)) {
                return true;
            }
        }
        return false;
    }

    public void lecture(double numberOfHours) {

        for(Student s: this.cohort) {
            s.learn(numberOfHours);
        }
    }

    public Map<Student, Double> getStudyMap() {

        Map<Student, Double> studentMap = new LinkedHashMap<>();
        for(Student s: this.cohort) {
            studentMap.put(s, s.getTotalStudyTime());
        }

        return studentMap;
    }
}
