package rocks.zipcode.io.quiz4.generics;

import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

/**
 * @author leon on 18/12/2018.
 */
public class Group<T> implements Iterable, GroupInterface {

    List<T> groupList;

    public Group() {
        this.groupList = new ArrayList<>();
    }

    public Integer count() {
        return this.groupList.size();
    }

    @Override
    public Boolean has(Object valueToInsert) {
        return this.groupList.contains(valueToInsert);
    }


    public T fetch(int indexOfValue) {
        return this.groupList.get(indexOfValue);
    }

    @Override
    public void insert(Object string) {
        this.groupList.add((T) string);
    }

    @Override
    public void delete(Object valueToInsert) {
        this.groupList.remove(valueToInsert);
    }

    public void clear() {
        this.groupList.clear();
    }


    @Override
    public Iterator iterator() {
        return this.groupList.iterator();
    }

    @Override
    public String toString() {
        StringBuilder str = new StringBuilder();
        str.append("[");
        for(T item: this.groupList){
            str.append(item.toString() + ", ");
        }
        str.delete(str.length() - 2, str.length());
        str.append("]");

        return str.toString();
    }
}
